/* 
  $Header: tools1.h,v 1.13 93/08/30 11:01:44 hmallat Exp $
  */

#ifndef TOOLS1

#include "tools.h"
#include "list.h"

color 
  cur_color;
const int 
  skip_value;
int 
  ab_max_r, ab_flow, b_w, b_h, cancelled, counter, cur_block_type,
  cur_fill_type, cur_hotspot, cur_tool, fill_tolerance, filled, first_x,
  first_y, grid, grid_x, grid_y, last, left, limit, perimeter, prev_x, prev_y,
  rgb_mode, scope, select_tolerance, show_edges, snap, x_off, y_off,
  xx, yy;
pixel 
  copy_bits;
struct picture 
  *brush, *cur_block, *cur_pic, *fill_pattern, *user1_b, *user2_b, *user3_b;
struct plist 
  *pixel_p;
struct view 
  *cur_view, *head_p;

void list_pixel(int x, int y);
void add_coords(int x, int y);
void del_coords();
void toolbranch(struct view *v_p, int x, int y, int button, int kind);
void cursor_appearance();
void draw_brush(struct view *v_p, int x, int y, int flag);
void flagbranch(int which);
void invert();
void darken(int p);
void brighten(int p);
void rgb_adjust(double pr, double pg, double pb, int ir, int ig, int ib);
void hsv_adjust(double h, double s, double v);
void add_noise(int range);
void matrix(double mul, double div, double *mat);
void vflip();
void hflip();
void resize(int width, int height);
void rotate(double angle, int cw);
int need_grab();
void set_mode();
void set_tool(int tool);
void set_copy_bits(long bits);
void set_select_tolerance(int n);
void set_block_to_screen(BLOCK function);
void set_grid(int s, int g, int gx, int gy);
void print_tool();
void update_menu();
void create_brush(int which, int size);
void set_hotspot(int which);
char *give_brush(int which, int maxsiz, int *w, int *h);
void create_fill(int which, int size, int tolerance);
void set_airbrush(int size, int flow);
void update_edge();
void select_all();
void deselect_all();
void give_color(struct view *v_p, int *r_p, int *g_p, int *b_p, int which);
void take_color(struct view *v_p, int r, int g, int b, int which);
void blockade(int x1, int y1, int x2, int y2, int all);
char *feed_block(struct picture *pic_p, int x1, int y1, int x2, int y2, 
		 int scale);
char *colored_block(int r, int g, int b, int width, int height);
void all_busy();
void all_busy_nomore();
void draw_grid(struct picture *pic_p, int x1, int y1, int x2, int y2);
#define TOOLS1
#endif

